//CouleursEnGris_noms_302f.js
// 04.06.13 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Convertir les couleurs en niveaux de gris

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// tester s'il y a un document ouvert
if (app.documents.length == 0) {
	alert ("Il n'y a pas de document ouvert.", "Attention");
	exit();
}

// le document au premier plan
var curDoc = app.documents[0];

// mmoriser les noms des couleur et leur nombre
var allNames  = curDoc.swatches.everyItem().name;
var nSwatches = allNames.length;
var ctr = 0;

// une boucle  travers les nuances
for (var s=0; s<nSwatches; s++) {
	var colName = allNames[s];
	if (colName != "None" && colName != "Registration" && colName != "Paper" && colName != "Black") {
		// l'objet couleur actuel
		var curColor = curDoc.colors.itemByName(colName);
		// une boucle unique
		for (var x=0; x<1; x++) {
			// convertir en CMJN
			try {
				curColor.space = ColorSpace.CMYK;
				// mmoriser le nom (il se peut qu'il soit modifi)...
				colNameMod = curDoc.swatches[ctr].name;
				// ... et appliquer l'objet  nouveau
				curColor = curDoc.colors.itemByName(colNameMod);
			}
			catch (e) {
				ctr++;
				break;
			}
			// tester les valeurs CMJN
			var tmpVals = curColor.colorValue;
			var c = tmpVals[0];
			var m = tmpVals[1];
			var y = tmpVals[2];
			var k = tmpVals[3];
			// si le total des parts CMJ est plus grand que zro
			if (c+m+y > 0) {
				// relever la composition
				var comp = 0;
				if (c>0) { comp = comp+ 2; }
				if (m>0) { comp = comp+ 4; }
				if (y>0) { comp = comp+ 8; }
				if (k>0) { comp = comp+16;}
				// calculer la valeur du noir
				if      (comp ==  2) { gray = (c*0.5); }
				else if (comp ==  4) { gray = (m*0.5); }
				else if (comp ==  6) { gray = (c*0.45)+(m*0.45); }
				else if (comp ==  8) { gray = (y*0.25); }
				else if (comp == 10) { gray = (c*0.45)+(y*0.25); }
				else if (comp == 12) { gray = (m*0.45)+(y*0.25); }
				else if (comp == 14) { gray = (c*0.4)+(m*0.4)+(y*0.25); }
				else if (comp == 18) { gray = (c*0.5)+(k); }
				else if (comp == 20) { gray = (m*0.5)+(k); }
				else if (comp == 22) { gray = (c*0.45)+(m*0.45)+(k); }
				else if (comp == 24) { gray = (y*0.25)+(k); }
				else if (comp == 26) { gray = (c*0.4)+(y*0.2)+(k*0.8); }
				else if (comp == 28) { gray = (m*0.4)+(y*0.2)+(k*0.8); }
				else if (comp == 30) { gray = (c*0.35)+(m*0.35)+(y*0.2)+(k*0.8); }
				// arrondir vers le bas (si ncessaire)
				var kVal = Math.floor(gray);
				// si plus grand que 100
				if (kVal>100) {
					kVal = 100;
				}
				// composer le nouveau nom (= l'ancien nom plus le caractre "")
				var newName = colName + "";
				var newVals = [0,0,0,kVal];
				// tester si une nuance de ce nom existe dj
				try {
					testColor = curDoc.swatches.itemByName(newName).name;
					// si oui, appliquer le nouveau nom  la variable
					newColor  = curDoc.swatches.itemByName(newName);
				}
				catch (e) {
					// sinon, crer une nouvelle nuance
					newColor  = curDoc.colors.add();
					newColor.model = ColorModel.PROCESS;
					newColor.space = ColorSpace.CMYK;
					newColor.name  = newName;
					newColor.colorValue = newVals;
				}
				// supprimer la nuance actuelle et la remplacer par la nouvelle
				try {
					curDoc.swatches.itemByName(colNameMod).remove(curDoc.swatches.itemByName(newColor.name));
				}
				catch (e) {
					ctr++;
				}
			}
			else {
				ctr++;
			}
		}
	}
	else {
		ctr++;
	}
}

// mmoriser les noms des couleurs et leur nombre
var allNames = curDoc.swatches.everyItem().name;
var nColors  = allNames.length;

// renommer les nuances en supprimant le caractre ajout temporairement
for (var s=0; s<nColors; s++) {
	var colName = allNames[s];
	if (colName.charAt(colName.length-1) == "") {
		try {
			var defName  = colName.slice(0,-1);
			curDoc.swatches.itemByName(colName).name = defName;
		}
		catch (e) {
		}
	}
}

// annoncer la fin de l'action
var dlog = new Window("palette");
dlog.size = [320,100];
dlog.add("statictext", [80, 100, 320, 116], "Termin.");
dlog.show();
// une petite pause
$.sleep(999);
// fermer la fentre
dlog.close();